#define _PING_CPP
#include <Arduino.h>
//#include <Servo.h>
#include "TimbreMinds_i.h"
//--------------------------------------------------------------
// ping funton -- input the pin, output the dicens in cm
//--------------------------------------------------------------
float ping(int pingPin){
  // request data from the ping senser
  pinMode(pingPin, OUTPUT);
  digitalWrite(pingPin, LOW);
  delayMicroseconds(2);
  digitalWrite(pingPin, HIGH);
  delayMicroseconds(5);
  digitalWrite(pingPin, LOW);
  
  // resave the data
  pinMode(pingPin, INPUT);
  float duration = pulseIn(pingPin, HIGH);
  
  // convert the data to cm and return the data
  return duration / 29 / 2;
}

/*
//--------------------------------------------------------------
// all ping senser funton -- input the pinArray, output the dicens in cm
//--------------------------------------------------------------
float* allPing(int pins[]){
  // (sizeof(myInts)/sizeof(int)) is how I get the langth of the array
  // set a list that can hold the data
  float cm[(sizeof(pins)/sizeof(int))];
  // for loop -- use a loop to get data from each ping senser
  for (int i = 0; i < (sizeof(pins)/sizeof(int)); i++){
    cm[i] = ping(pins[i]);
  }
  // return the data
  return cm;
}
*/

boolean pingThreshold(float threshold, int pingPin){
  float data = ping(pingPin);
  if (data < threshold){
    return true;
  }else{
    return false;
  }
}

char pingThRespon(float pingThresholdValue,int pingPins[]){
  if (pingThreshold(pingThresholdValue, pingPins[0])){
    return 'L';
  }else if (pingThreshold(pingThresholdValue, pingPins[2])){
    return 'F';
  }else if (pingThreshold(pingThresholdValue, pingPins[4])){
    return 'F';
  }else{
    return 'o';
  }
}

/* //OLD
boolean pingsThreshold (float threshold,int pingPin){
  float* data = allPing(pingPin);
  boolean triger[(sizeof(data)/sizeof(int))];
  for (int i = 0; i < (sizeof(data)/sizeof(int)); i++){
    if (data[i] < threshold){
      triger[i] = true;
    }else{
      triger[i] = false;
    }
  }
  return triger;
}
char pingThRespon(float pingThresholdValue,int pingPin){
  //long pingThresholdValue = 8;
  boolean trigers = pingsThreshold(pingThresholdValue,pingPin);
  if (trigers[1]){
    return "LF";
  }else if(trigers[3]){
    return "RF";
  }else if(trigers[2]){
    return "F";
  }else if(trigers[0]){
    return "L";
  }else if(trigers[4]){
    return "R";
  }else{
    return "";
  }
}
*/
